//
//  PhotoZoom.h
//
//

#import <Foundation/Foundation.h>
#import "PZPagingScrollView.h"
#import "PZPhotoView.h"

@interface PhotoZoom : UIView <PZPagingScrollViewDelegate, PZPhotoViewDelegate>

@property (weak, nonatomic) IBOutlet UIViewController * viewController;
@property (weak, nonatomic) IBOutlet id inputDataSource;

- (void)setImageURLs:(id)imageURLs;
- (void)setSpaceBetweenImages:(int)space;
- (void)setBindingsInfoString:(NSString *)bindingsInfoString;

@end
